import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;
import java.io.*;

public class HelloClient implements AskUser
{
	public boolean ask(String question)
	{
		String input = "";
		while (!input.equals("Y") && !input.equals("N")) {
			System.out.println(question);
			BufferedReader in = new BufferedReader(
									new InputStreamReader(System.in));
			try {
				input = in.readLine();
			}
			catch (Exception e) {
				System.out.println("Input Error!");
			}
		}
		return (input.equals("Y"));
	}

	void doWork()
	{
		String message;
		Hello obj;

		try {
			// Obektreferenz ber Namensdienst besorgen
			obj = (Hello)Naming.lookup("rmi://localhost/Hello-Server");

			// Remote Methode aufrufen
			message = obj.sayHello(this);

			System.out.println(message);
		}
		catch (Exception e) {
			System.out.println("HelloClient: " + e.getMessage());
			e.printStackTrace();
		}
	}

	public static void main(String args[])
	{
		// Client-Objekt erzeugen
		HelloClient me = new HelloClient();

		// Objekt als RMI-Objekt zur Verfgung stellen
		// Als Port wird hier 0 angegeben ==> beliebiger freier Port
		// Der Aufruf UnicastRemoteObject.exportObject(me) verlangt auch
		// bei JDK 1.5 und neuer einen mit rmic erzeugten Stub!
		try {
			UnicastRemoteObject.exportObject(me,0);
		}
		catch (Exception e) {
			System.out.println("HelloClient exportObject: " + e.getMessage());
			e.printStackTrace();
		}

		// Client starten
		me.doWork();

		// Objekt als RMI-Objekt abschalten, damit Client terminieren kann!
		try {
			UnicastRemoteObject.unexportObject(me, false);
		}
		catch (Exception e) {
			System.out.println("HelloClient unexportObject: " + e.getMessage());
			e.printStackTrace();
		}
	}
}

